/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

/*

Originally created by: Jonathan Drake
Last Modified: November 10th 2005

Apple's copyright is in regards to the code that implements the flip mechanism.
Copyright 2005 Jonathan Drake and ITV Northwest.

*/

// Make sure it doesn't remember when it loads up
widget.setPreferenceForKey("notset","episode");

// Creates the video select element for the preferences section
function createSelect(title) 
{

	select = document.createElement("select");
	
	// Set the attributes
	select.setAttribute("id", title + "Popup");
	select.setAttribute("onchange", 'change' + title + '(this);');
	
	// Add the element
	divBack.appendChild(select);

}

// Creates an option for the select element
function createOption(increment, name, title) 
{
	
	option = document.createElement("option");

	// Set the attributes
	
	option.setAttribute("id", title + increment);
	
	option.setAttribute("value", increment);
	
	
	// Set the title and add it
	option.innerHTML = name;
	
	select.appendChild(option);
	

}

// Creates the video when selected from preferences
function createVideo(location) 
{

	var videoObject = document.createElement("object");
	var src = document.createElement("param");
	var autoplay = document.createElement("param");
	var controller = document.createElement("param");
	var scale = document.createElement("param");
	var bgcolor = document.createElement("param");
	var pluginspage = document.createElement("param");
	var embed = document.createElement("embed");
	
	// Set the numerous attributes for the object element
	videoObject.setAttribute("classid", "clsid:02bf25d5-8c17-4b23-bc80-d3488abddc6b");
	videoObject.setAttribute("codebase", "http://www.apple.com/qtactivex/qtplugin.cab");
	videoObject.setAttribute("width", "320"); 
	videoObject.setAttribute("height", "256");
	videoObject.setAttribute("border", "0"); 
	videoObject.setAttribute("align", "baseline"); 
	videoObject.setAttribute("id", "videoObject");
	
	// Finish with attributes for embed
	embed.setAttribute("width", "320");
	embed.setAttribute("height", "256");
	embed.setAttribute("border", "0");
	embed.setAttribute("align", "baseline");
	embed.setAttribute("src", location);
	embed.setAttribute("autplay", "true");
	embed.setAttribute("controller", "true");
	embed.setAttribute("scale", "aspect");
	embed.setAttribute("bgcolor", "white");
	embed.setAttribute("pluginspage", "http://www.apple.com/quicktime/download/");
	
	// Finally lets add the elements to the page
	videoSpan.appendChild(videoObject);
	
	videoObject.appendChild(src);
	videoObject.appendChild(autoplay);
	videoObject.appendChild(controller);
	videoObject.appendChild(scale);
	videoObject.appendChild(bgcolor);
	videoObject.appendChild(pluginspage);
	videoObject.appendChild(embed);
	
}

// Function is called when the category select statement is changed
function changeCat(elem)
{
	
	divBack = document.getElementById("back");
	
	if (seasonSelect = document.getElementById("seasonPopup")) 
		divBack.removeChild(seasonSelect);
		
	if (videoSelect = document.getElementById("videoPopup")) 
		divBack.removeChild(videoSelect);
		
	widget.setPreferenceForKey("notset","episode");
	
	// Checks which option was selected and creates the needed season select
	switch( parseInt(elem.options[elem.selectedIndex].value) )				
	{
	
		case 1:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(11, "Season 1", "season");
			break;
		case 2:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(21, "Season 1", "season");
			break;
		case 3:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(31, "Season 1", "season");
			break;
		case 4:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(41, "Season 1", "season");
			break;
		case 5:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(51, "Season 1", "season");
			break;
		case 6:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(61, "Season 1", "season");
			break;
		case 7:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(71, "Season 1", "season");
			break;
		case 8:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(81, "Season 1", "season");
			break;	
		case 9:
			createSelect("season");
			createOption(0, "Select One", "season");
			createOption(91, "Season 1", "season");
			break;
		//case 10:
			//createSelect("season");
			//createOption(0, "Select One", "season");
			//createOption(101, "Season 1", "season");
			//break;
	}
	


}

// Function is called when the season select statement is changed
function changeseason(elem)
{
	
	divBack = document.getElementById("back");
	
	if (videoSelect = document.getElementById("videoPopup")) 
		divBack.removeChild(videoSelect);
		
	// Checks which option was selected and creates the needed video select
	switch( parseInt(elem.options[elem.selectedIndex].value) )				
	{
	
		case 11:
			createSelect("video");
			createOption(1001, "Episode 1", "video");
			break;
		case 21:
			createSelect("video");
			createOption(2001, "Pilot", "video");
			break;
		case 31:
			createSelect("video");
			createOption(3001, "Pilot", "video");
			break;
		case 41:
			createSelect("video");
			createOption(4001, "Pilot", "video");
			break;
		case 51:
			createSelect("video");
			createOption(5001, "Pilot", "video");
			break;
		case 61:
			createSelect("video");
			createOption(6001, "Pilot", "video");
			break;
		case 71:
			createSelect("video");
			createOption(7001, "Pilot", "video");
			break;
		case 81:
			createSelect("video");
			createOption(8001, "Pilot", "video");
			break;	
		case 91:
			createSelect("video");
			createOption(9001, "Pilot", "video");
			break;
		//case 101:
			//createSelect("video");
			//createOption(10001, "Pilot", "video");
			//break;
	}
	
	videlem = document.getElementById("videoPopup");
	
	changevideo(videlem);

}


// Checks the selected video and loads it into the player
function changevideo(videlem)
{

	divBack = document.getElementById("back");
	
	videoSpan = document.getElementById("wholeVideo");
	
	if (videoObject = document.getElementById("videoObject"))
		videoSpan.removeChild(videoObject);
	
	//divBack.removeChild(document.getElementById("catPopup"));
	
	switch( parseInt(videlem.options[videlem.selectedIndex].value) )
	{
		case 1001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVHighlightsRef.mov","currentLocation");
			widget.setPreferenceForKey("HighlightsReel","episode");
			break;
		case 2001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVLiveMusicPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("LIveMusicPilot","episode");
			break;
		case 3001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVSportsPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("SportsPilot","episode");
			break;
		case 4001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVNightlifePilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("NightlifePilot","episode");
			break;
		case 5001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVFilmPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("ShortFilmsPilot","episode");
			break;
		case 6001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVArtPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("ArtPilot","episode");
			break;
		case 7001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVRestaurantsPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("ResturantsPilot","episode");
			break;
		case 8001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVVideoGamesPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("VideoGamesPilot","episode");
			break;
		case 9001:
			widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVFashionPilotRef.mov", "currentLocation");
			widget.setPreferenceForKey("FashionPilot","episode");
			break;
		//case 10001:
			//widget.setPreferenceForKey("http://www.itvnw.com/ITV/ITVShowRefQTSS/ITVImprovPilotRef.mov", "currentLocation");
			//widget.setPreferenceForKey("ImprovPilot","episode");
			//break;
	}

}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
	
}

function prepareHide()
{
	// Test to see if they actually selected a video and if so load it
	if (widget.preferenceForKey("episode") != "notset")
	{
		videoSpan = document.getElementById("wholeVideo");
		
		if (videoObject = document.getElementById("videoObject"))
			videoSpan.removeChild(videoObject);
	
		var location = widget.preferenceForKey("currentLocation");
		
		//rebuild it with the new location
		createVideo(location);
		
		// create the alt link
		var altLink = document.getElementById("alternateLink");
		
		altLink.innerHTML = 'Click here if connection times out';
		
	}
	
	hidePrefs();
}

// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	var videlem = document.getElementById("videoPopup");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}

// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}

}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function loadAlt()
{

	var episode = widget.preferenceForKey("episode");
	
	var location = "http://www.itvnw.com/ITV/ITV" + episode + "DL.html";
	widget.openURL(location);

}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}